var NAVTREE =
[
  [ "QOF", "index.html", [
    [ "QOF design and developers reference", "index.html", null ],
    [ "Related Pages", "pages.html", [
      [ "QOF Backend Design", "backendapi.html", null ],
      [ "Handling Backend Communications Errors", "backenderrors.html", null ],
      [ "Useful tips for doxygen in C files", "tipshints.html", null ],
      [ "Doxygen reference documentation", "reference.html", null ],
      [ "QofNumeric Example", "qofnumericexample.html", null ],
      [ "QOF, applications and the use of QSF maps.", "qsfmaps.html", null ],
      [ "QofDate and locales.", "datelocales.html", null ],
      [ "Todo List", "todo.html", null ],
      [ "Deprecated List", "deprecated.html", null ],
      [ "Bug List", "bug.html", null ]
    ] ],
    [ "Modules", "modules.html", [
      [ "Query Object Framework", "group__QOF.html", [
        [ "Book:        The QOF Data Set.", "group__Book.html", null ],
        [ "Object:    Describing data structure.", "group__Object.html", [
          [ "Object_Private", "group__Object__Private.html", null ],
          [ "GLib GObjects", "group__GObject.html", null ]
        ] ],
        [ "Class:      Getting and setting entity values.", "group__Class.html", [
          [ "GUID", "group__GUID.html", null ],
          [ "Entity", "group__Entity.html", null ],
          [ "Instance", "group__Instance.html", null ]
        ] ],
        [ "Time:     64bit UTC Time handling.", "group__QOFTIME.html", [
          [ "Date: 64bit UTC date handling.", "group__Date.html", null ]
        ] ],
        [ "Numeric:  Rational Number Handling with Rounding Error Control", "group__Numeric.html", [
          [ "Math128", "group__Math128.html", null ]
        ] ],
        [ "KVP:          Key-Value Pairs", "group__KVP.html", null ],
        [ "Backends: Permanent storage for QOF entities.", "group__Backend.html", [
          [ "Session: Backend connections.", "group__Session.html", null ],
          [ "QOF Serialisation Format", "group__QSF.html", null ],
          [ "qof-backend-gda outline", "group__LibGda.html", null ],
          [ "QOF-backend-SQLite support", "group__SQLite.html", null ]
        ] ],
        [ "Query:      Querying for Objects", "group__Query.html", [
          [ "SQL Interface to Query", "group__SQL.html", null ]
        ] ],
        [ "Error: Extensible error handling.", "group__Error.html", null ],
        [ "Trace:      Debugging support", "group__Trace.html", null ],
        [ "Event:      QOF event handlers.", "group__Event.html", null ],
        [ "Choice:    One to many links.", "group__Choice.html", null ],
        [ "Merge:  Merging QofBook structures", "group__BookMerge.html", null ],
        [ "Reference: Referring to entities outside a partial book.", "group__Reference.html", null ],
        [ "Undo:        Track and undo or redo entity changes", "group__UNDO.html", null ],
        [ "Utilities: Miscellany", "group__Utilities.html", null ]
      ] ]
    ] ],
    [ "Data Structures", "annotated.html", [
      [ "_GUID", "union__GUID.html", null ],
      [ "_QofBook", "struct__QofBook.html", null ],
      [ "_QofNumeric", "struct__QofNumeric.html", null ],
      [ "_QofObject", "struct__QofObject.html", null ],
      [ "_QofParam", "struct__QofParam.html", null ],
      [ "_QofQueryPredData", "struct__QofQueryPredData.html", null ],
      [ "_QofSession", "struct__QofSession.html", null ],
      [ "bin_data", "structbin__data.html", null ],
      [ "GHashTableKVPair", "structGHashTableKVPair.html", null ],
      [ "HandlerInfo", "structHandlerInfo.html", null ],
      [ "md5_ctx", "structmd5__ctx.html", null ],
      [ "qof_entity_reference", "structqof__entity__reference.html", null ],
      [ "QofBackend_s", "structQofBackend__s.html", null ],
      [ "QofBackendOption_s", "structQofBackendOption__s.html", null ],
      [ "QofBackendProvider_s", "structQofBackendProvider__s.html", null ],
      [ "QofBookMergeData", "structQofBookMergeData.html", null ],
      [ "QofBookMergeRule", "structQofBookMergeRule.html", null ],
      [ "QofDate_s", "structQofDate__s.html", null ],
      [ "QofEntity_s", "structQofEntity__s.html", null ],
      [ "QofInstance_s", "structQofInstance__s.html", null ],
      [ "QofInt128", "structQofInt128.html", null ],
      [ "QofUndo_s", "structQofUndo__s.html", null ],
      [ "QsfMetadata_s", "structQsfMetadata__s.html", null ],
      [ "QsfNodeIterate", "structQsfNodeIterate.html", null ],
      [ "QsfObject_s", "structQsfObject__s.html", null ],
      [ "QsfValidates_s", "structQsfValidates__s.html", null ],
      [ "query_boolean_def", "structquery__boolean__def.html", null ],
      [ "query_char_def", "structquery__char__def.html", null ],
      [ "query_choice_def", "structquery__choice__def.html", null ],
      [ "query_coll_def", "structquery__coll__def.html", null ],
      [ "query_date_def", "structquery__date__def.html", null ],
      [ "query_double_def", "structquery__double__def.html", null ],
      [ "query_guid_def", "structquery__guid__def.html", null ],
      [ "query_int32_def", "structquery__int32__def.html", null ],
      [ "query_int64_def", "structquery__int64__def.html", null ],
      [ "query_kvp_def", "structquery__kvp__def.html", null ],
      [ "query_numeric_def", "structquery__numeric__def.html", null ],
      [ "query_string_def", "structquery__string__def.html", null ],
      [ "query_time_def", "structquery__time__def.html", null ],
      [ "timespec64", "structtimespec64.html", null ]
    ] ],
    [ "Data Structure Index", "classes.html", null ],
    [ "Data Fields", "functions.html", null ],
    [ "File List", "files.html", [
      [ "deprecated.c", null, null ],
      [ "deprecated.h", "deprecated_8h.html", null ],
      [ "doxygen_main_page.c", null, null ],
      [ "guid.c", null, null ],
      [ "guid.h", "guid_8h.html", null ],
      [ "kvpframe.c", null, null ],
      [ "kvpframe.h", "kvpframe_8h.html", null ],
      [ "kvputil-p.h", "kvputil-p_8h.html", null ],
      [ "kvputil.c", null, null ],
      [ "kvputil.h", "kvputil_8h.html", null ],
      [ "md5.c", null, null ],
      [ "md5.h", null, null ],
      [ "qof-backend-qsf.h", "qof-backend-qsf_8h.html", null ],
      [ "qof-gda.c", "qof-gda_8c.html", null ],
      [ "qof-gda.h", "qof-gda_8h.html", null ],
      [ "qof-sqlite.c", "qof-sqlite_8c.html", null ],
      [ "qof-sqlite.h", "qof-sqlite_8h.html", null ],
      [ "qof.h", null, null ],
      [ "qofbackend-p.h", "qofbackend-p_8h.html", null ],
      [ "qofbackend.c", null, null ],
      [ "qofbackend.h", "qofbackend_8h.html", null ],
      [ "qofbook-p.h", "qofbook-p_8h.html", null ],
      [ "qofbook.c", null, null ],
      [ "qofbook.h", "qofbook_8h.html", null ],
      [ "qofbookmerge.c", null, null ],
      [ "qofbookmerge.h", "qofbookmerge_8h.html", null ],
      [ "qofchoice.c", null, null ],
      [ "qofchoice.h", "qofchoice_8h.html", null ],
      [ "qofclass-p.h", null, null ],
      [ "qofclass.c", null, null ],
      [ "qofclass.h", "qofclass_8h.html", null ],
      [ "qofdate-p.h", null, null ],
      [ "qofdate.c", null, null ],
      [ "qofdate.h", "qofdate_8h.html", null ],
      [ "qoferror-p.h", null, null ],
      [ "qoferror.c", null, null ],
      [ "qoferror.h", "qoferror_8h.html", null ],
      [ "qofevent-p.h", null, null ],
      [ "qofevent.c", null, null ],
      [ "qofevent.h", "qofevent_8h.html", null ],
      [ "qofgobj.c", null, null ],
      [ "qofgobj.h", "qofgobj_8h.html", null ],
      [ "qofid-p.h", null, null ],
      [ "qofid.c", null, null ],
      [ "qofid.h", "qofid_8h.html", null ],
      [ "qofinstance-p.h", null, null ],
      [ "qofinstance.c", null, null ],
      [ "qofinstance.h", "qofinstance_8h.html", null ],
      [ "qofla-dir.h", null, null ],
      [ "qoflog.c", null, null ],
      [ "qoflog.h", "qoflog_8h.html", null ],
      [ "qofmath128.c", null, null ],
      [ "qofmath128.h", null, null ],
      [ "qofnumeric.c", null, null ],
      [ "qofnumeric.h", "qofnumeric_8h.html", null ],
      [ "qofobject-p.h", "qofobject-p_8h.html", null ],
      [ "qofobject.c", null, null ],
      [ "qofobject.h", "qofobject_8h.html", null ],
      [ "qofquery-deserial.h", null, null ],
      [ "qofquery-p.h", null, null ],
      [ "qofquery-serialize.h", null, null ],
      [ "qofquery.c", null, null ],
      [ "qofquery.h", "qofquery_8h.html", null ],
      [ "qofquerycore-p.h", null, null ],
      [ "qofquerycore.c", null, null ],
      [ "qofquerycore.h", "qofquerycore_8h.html", null ],
      [ "qofreference.c", null, null ],
      [ "qofreference.h", "qofreference_8h.html", null ],
      [ "qofsession-p.h", null, null ],
      [ "qofsession.c", "qofsession_8c.html", null ],
      [ "qofsession.h", "qofsession_8h.html", null ],
      [ "qofsql.c", "qofsql_8c.html", null ],
      [ "qofsql.h", "qofsql_8h.html", null ],
      [ "qofstrftime.c", null, null ],
      [ "qofstrptime.c", null, null ],
      [ "qoftime.c", null, null ],
      [ "qoftime.h", "qoftime_8h.html", null ],
      [ "qofundo-p.h", null, null ],
      [ "qofundo.c", null, null ],
      [ "qofundo.h", "qofundo_8h.html", null ],
      [ "qofutil.c", null, null ],
      [ "qofutil.h", "qofutil_8h.html", null ],
      [ "qsf-backend.c", null, null ],
      [ "qsf-dir.h", null, null ],
      [ "qsf-xml-map.c", null, null ],
      [ "qsf-xml.c", null, null ],
      [ "qsf-xml.h", "qsf-xml_8h.html", null ],
      [ "test-book-merge.c", null, null ],
      [ "test-date.c", null, null ],
      [ "test-engine-stuff.c", "test-engine-stuff_8c.html", null ],
      [ "test-engine-stuff.h", "test-engine-stuff_8h.html", null ],
      [ "test-event.c", null, null ],
      [ "test-guid.c", null, null ],
      [ "test-numeric.c", null, null ],
      [ "test-object.c", null, null ],
      [ "test-querynew.c", null, null ],
      [ "test-recursive.c", null, null ],
      [ "test-stuff.c", null, null ],
      [ "test-stuff.h", null, null ]
    ] ],
    [ "Globals", "globals.html", null ]
  ] ]
];

function createIndent(o,domNode,node,level)
{
  if (node.parentNode && node.parentNode.parentNode)
  {
    createIndent(o,domNode,node.parentNode,level+1);
  }
  var imgNode = document.createElement("img");
  if (level==0 && node.childrenData)
  {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() 
    {
      if (node.expanded) 
      {
        $(node.getChildrenUL()).slideUp("fast");
        if (node.isLast)
        {
          node.plus_img.src = node.relpath+"ftv2plastnode.png";
        }
        else
        {
          node.plus_img.src = node.relpath+"ftv2pnode.png";
        }
        node.expanded = false;
      } 
      else 
      {
        expandNode(o, node, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
  }
  else
  {
    domNode.appendChild(imgNode);
  }
  if (level==0)
  {
    if (node.isLast)
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2plastnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2lastnode.png";
        domNode.appendChild(imgNode);
      }
    }
    else
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2pnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2node.png";
        domNode.appendChild(imgNode);
      }
    }
  }
  else
  {
    if (node.isLast)
    {
      imgNode.src = node.relpath+"ftv2blank.png";
    }
    else
    {
      imgNode.src = node.relpath+"ftv2vertline.png";
    }
  }
  imgNode.border = "0";
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  a.appendChild(node.label);
  if (link) 
  {
    a.href = node.relpath+link;
  } 
  else 
  {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
      node.expanded = false;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() 
  {
    if (!node.childrenUL) 
    {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
}

function expandNode(o, node, imm)
{
  if (node.childrenData && !node.expanded) 
  {
    if (!node.childrenVisited) 
    {
      getNode(o, node);
    }
    if (imm)
    {
      $(node.getChildrenUL()).show();
    } 
    else 
    {
      $(node.getChildrenUL()).slideDown("fast",showRoot);
    }
    if (node.isLast)
    {
      node.plus_img.src = node.relpath+"ftv2mlastnode.png";
    }
    else
    {
      node.plus_img.src = node.relpath+"ftv2mnode.png";
    }
    node.expanded = true;
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) 
  {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
        i==l);
  }
}

function findNavTreePage(url, data)
{
  var nodes = data;
  var result = null;
  for (var i in nodes) 
  {
    var d = nodes[i];
    if (d[1] == url) 
    {
      return new Array(i);
    }
    else if (d[2] != null) // array of children
    {
      result = findNavTreePage(url, d[2]);
      if (result != null) 
      {
        return (new Array(i).concat(result));
      }
    }
  }
  return null;
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;

  getNode(o, o.node);

  o.breadcrumbs = findNavTreePage(toroot, NAVTREE);
  if (o.breadcrumbs == null)
  {
    o.breadcrumbs = findNavTreePage("index.html",NAVTREE);
  }
  if (o.breadcrumbs != null && o.breadcrumbs.length>0)
  {
    var p = o.node;
    for (var i in o.breadcrumbs) 
    {
      var j = o.breadcrumbs[i];
      p = p.children[j];
      expandNode(o,p,true);
    }
    p.itemDiv.className = p.itemDiv.className + " selected";
    p.itemDiv.id = "selected";
    $(window).load(showRoot);
  }
}

